const http = require('http');
const https = require('https');
const url = require('url');

const { createRequestObj, createResponseObj} = require('./utils');

class Server {
    constructor(options) {
        this.request = {};
        this.response = {};
        this.routes = [];
        this.port = options.port;

        this.server = (options && options.ssl) ? https.createServer(options.ssl) : http.createServer();
        this.server.on('connection', () => {
            console.log('Server connection established: OK');
            this.server.on("end", function() {
              console.log('Server connection lost!');
            });
        });
    }

    addRoute(path, method, callback) {
        this.routes.push({
            path,
            method,
            callback,
        });
    }

    listen() {
        this.port = this.port || this.server.address().port;

        this.server.on('request', (req, res) => {
            this.request = createRequestObj(req, url.parse(req.url, true));
            this.response = createResponseObj(res);

            console.log(this.request.method);
            console.log(this.request.path);

            console.log(this.routes);
            if(this.routes.some(route => route.path === this.request.path && route.method ===  this.request.method)) {
                this.routes.filter(route => route.path === this.request.path  && route.method ===  this.request.method)[0].callback(this.request, this.response);
            }
            else {
                res.writeHead(404);
                res.end();
            }
        });
        this.server.listen(this.port);
        console.log(`Server listening on port: ${this.port}`);
    }

    end() {
        this.server.close();
        console.log(`Server closed: OK`);
    }
}

module.exports = Server;
